#ifndef __POINT2D_H
#define __POINT2D_H


#include "Real.h"
#include "Serializable.h"

class Point2D : public Serializable
{
private:
	
	real m_x;
	real m_y;

public:

	Point2D(real x = 0, real y = 0) : m_x(x), m_y(y) { };
	virtual ~Point2D() { };

	real GetX() const throw() {return m_x;};
	real GetY() const throw() {return m_y;};

	void SetX(real x) throw() {m_x = x;};
	void SetY(real y) throw() {m_y = y;};

	
	/** Serializable interface overrides */

	/// Reads a point from the stream.
	virtual void Read(ifstream & stream)
		throw(IOException, SerializationException);
	/// Writes a point to the stream.
	virtual void Write(ofstream & stream) const
		throw(IOException);
};

// Inline implementations




#endif // POINT3D_H
