// Rony!

// This header should be added to TexturedMesh.h
// in the public area.
real GetTotalEdgeLength();

// The implementation should be placed in TexturedMesh.cpp:
real TexturedMesh::GetTotalEdgeLength()
{
	real len = 0;

	if (m_edge_to_triangles_map.size() == 0)
		CreateEdgeToTrianglesMap();

	EdgeToIndicesMap::const_iterator it = m_edge_to_triangles_map.begin();
	for ( ; it != m_edge_to_triangles_map.end(); ++it)
	{
		len += Point3D::Distance(m_vertices[(it->first).first],
								 m_vertices[(it->first).second]);
	}

	return len;
}

// In test_flattening.cpp and test_norm_partition.cpp,
// after the line:
real seam_length = tm.CreatePatchBoundariesSet(mesh_vec, 
											   maps2Dtriangle_to_3Dtriangle);
// add the line
seam_length /= tm.GetTotalEdgeLength();