#include "Serializable.h"

/** The standard string is not supplied with a stream input reading
* operator, so we supply our own implementation here.
*/
ifstream & operator>>(ifstream & stream, std::string & str)
{
	static char cstr[256];
	str.assign("");
	unsigned int blanksCounter = 0;
	
	while(str.compare("")==0 || str[0] == ' ')
	{
		memset(cstr, sizeof(cstr), sizeof(cstr)/sizeof(*cstr));
		stream.getline(cstr, 256);
		str.assign(cstr);
		
		if (stream.eof())
		{
			str.assign("");
			return stream;
		}
	}
	
	return stream;
}

ofstream & operator<<(ofstream & stream, std::string & str)
{
	stream << str.c_str();
	return stream;
}