// Tripplet.cpp: implementation of the Tripplet class.
//
//////////////////////////////////////////////////////////////////////

#include "Tripplet.h"

//////////////////////////////////////////////////////////////////////
// Class Member Variables
//////////////////////////////////////////////////////////////////////
#include <limits.h>

const ULONG Tripplet::INVALID_INDEX = ULONG_MAX;

//////////////////////////////////////////////////////////////////////
// Member Functions
//////////////////////////////////////////////////////////////////////

void Tripplet::Read(ifstream & stream)
	throw(IOException, SerializationException)
{
    stream >> m_indices[0] >> m_indices[1] >> m_indices[2];

	// Check that all the indices are different so that they
	// compose a triangle
	assert(m_indices[0] != m_indices[1] &&
		m_indices[0] != m_indices[2] &&
		m_indices[1] != m_indices[2]);
}

void Tripplet::Write(ofstream & stream) const
	throw(IOException)
{
	// Check that all the indices are different so that they
	// compose a triangle
	assert(m_indices[0] != m_indices[1] &&
		m_indices[0] != m_indices[2] &&
		m_indices[1] != m_indices[2]);

    stream << m_indices[0] << " " << m_indices[1] << " " << m_indices[2] << " ";
}
