#include "myString.h"

#ifndef ATTRIBUTE_H
#define ATTRIBUTE_H

class Attribute {
public:
    Attribute(const myString * name, const myString * value,
              bool newLine = true) :
        m_newLine(newLine), m_name(name), m_value(value)
    { init(); }
    Attribute(const char * name, const myString * value, bool newLine = true) :
        m_newLine(newLine), m_name(new myString(name)), m_value(value)
    { init(); }
    Attribute(const char * name, const char * value, bool newLine = true) :
        m_newLine(newLine),
        m_name(new myString(name)), m_value(new myString(value))
    { init(); }

    void init();
    void exportXml() const;
    const myString * getName() const { return m_name; }
    const myString * getValue() const { return m_value; }

#ifdef _DEBUG
    static int getCount() { return m_count; }
#endif
    
private:
    const myString * m_name;
    const myString * m_value;

    bool m_newLine;
    
#ifdef _DEBUG
    static int m_count;
#endif
};

#endif
