BEGIN_GTBMOUSENS


inline bool CoordinateSystem::operator==(const CoordinateSystem &cs)
{
	return ((m_x == cs.m_x)
		&& (m_y == cs.m_y)
		&& (m_z == cs.m_z));
}


inline bool CoordinateSystem::operator!=(const CoordinateSystem &cs)
{
	return !(*this == cs);
}


inline const Point3 &CoordinateSystem::origin() const
{
	return m_origin;
}


inline const Vector3 &CoordinateSystem::x() const
{
	return m_x;
}


inline const Vector3 &CoordinateSystem::y() const
{
	return m_y;
}


inline const Vector3 &CoordinateSystem::z() const
{
	return m_z;
}


inline CoordinateSystem &CoordinateSystem::reset(const Point3 &a_origin,
						 const Vector3 &a_x,
						 const Vector3 &a_y,
						 const Vector3 &a_z)
{
	m_origin = a_origin;
	m_x = a_x;
	m_y = a_y;
	m_z = a_z;
	return *this;
}


END_GTBMOUSENS
