#ifndef ELEMENT_H
#define ELEMENT_H

#include <list>
#include "myString.h"

class Attribute;

class Element {
public:
    Element() : m_tag(0) { init(); }
    Element(const char * tag) : m_tag(new myString(tag)) { init(); }
    Element(const myString * tag) : m_tag(tag) { init(); }
    
    void set(const myString * tag) { m_tag = tag; }
    void set(const char * tag) { m_tag = new myString(tag); }

    void addAttribute(const Attribute * attribute, bool back = true);
    void addElement(const Element * element, bool back = true);
    void merge(const Element * element);
    
    virtual void exportXml() const;

    typedef std::list<const Attribute*> AttributeList;
    typedef std::list<const Element*> ElementList;

public:			/* adi: accessors begin */
	const AttributeList &getAttributes() const { return m_attributes; }
	const ElementList &getElements() const { return m_elements; }
	const myString *getTag() const { return m_tag; }	/* adi: accessors end */

#ifdef _DEBUG
    static int getCount() { return m_count; }
#endif

protected:
    void init();

    AttributeList m_attributes;
    ElementList m_elements;
    const myString * m_tag;

#ifdef _DEBUG
    static int m_count;
#endif
};

#endif
