#ifndef __GTBMOUSECOMMON_H
#define __GTBMOUSECOMMON_H

#pragma warning( disable : 4786 4284 34)

#include <windows.h>
#include <assert.h>
#include <errno.h>
#include <float.h>
#include <limits.h>
#include <math.h>
#include <stdarg.h>
#include <stdio.h>
//#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef min
#undef min
#undef max
#endif

// C++ stuff

#include <algorithm>
#include <iostream>
#include <list>
#include <map>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <queue>

#define for if (0); else for

#define BEGIN_GTBMOUSENS namespace gtbmouse {
#define END_GTBMOUSENS }

#ifndef M_PI
#define M_E             2.7182818284590452354
#define M_LOG2E         1.4426950408889634074
#define M_LOG10E        0.43429448190325182765
#define M_LN2           0.69314718055994530942
#define M_LN10          2.30258509299404568402
#define M_PI            3.14159265358979323846
#define M_PI_2          1.57079632679489661923
#define M_PI_4          0.78539816339744830962
#define M_1_PI          0.31830988618379067154
#define M_2_PI          0.63661977236758134308
#define M_2_SQRTPI      1.12837916709551257390
#define M_SQRT2         1.41421356237309504880
#define M_SQRT1_2       0.70710678118654752440
#endif // M_PI

typedef double real_t;

template <class T>
T min(const T & lhs, const T & rhs)
{
	if (lhs < rhs)
		return lhs;
	else
		return rhs;
}

template <class T>
T max(const T & lhs, const T & rhs)
{
	if (lhs > rhs)
		return lhs;
	else
		return rhs;
}

#endif // __GTBMOUSECOMMON_H
