#ifndef GTB_KEYBOARD_INCLUDED
#define GTB_KEYBOARD_INCLUDED

#include "gtbmousecommon.h"


#ifdef WIN32
BEGIN_GTBMOUSENS

class keyboard {
public:
	enum t_modifiers {key_ctrl, key_shift, key_alt};

	// Hack to work around bug in GLUT, which does not generate
	// KeyPress or KeyRelease events fot the modifiers.
	static bool is_key_pressed(t_modifiers key);
	static bool is_shift_pressed();
	static bool is_control_pressed();
	static bool is_alt_pressed();
};

END_GTBMOUSENS

#else // WIN32

#include <X11/Xlib.h>
#include <X11/keysym.h>

BEGIN_GTBMOUSENS

class keyboard {
public:
	// Hack to work around bug in GLUT, which does not generate
	// KeyPress or KeyRelease events fot the modifiers.
	static bool is_key_pressed(int keysym);
	static bool is_shift_pressed();
	static bool is_control_pressed();
	static bool is_alt_pressed();
	static void print_keys_pressed();

protected:
	static Display *init_display();
	static Display *_disp;
};

END_GTBMOUSENS

#endif // WIN32


#endif // GTB_KEYBOARD_INCLUDED
