BEGIN_GTBMOUSENS


inline Line3 &Line3::operator=(const Line3 &l)
{
	if (&l != this) {
		_p = l._p;
		_d = l._d;
	}
	return *this;
}


inline bool Line3::contains(const Point3 &p) const
{
	return (p - _p).cross(_d).is_zero();
}


inline bool Line3::operator==(const Line3 &l) const
{
	return (_d == l._d) && contains(l._p);
}


inline bool Line3::operator!=(const Line3 &l) const
{
	return !(*this == l);
}


inline Line3 Line3::operator-() const
{
	return Line3(_p, -_d);
}


inline const Vector3 &Line3::direction() const
{
	return _d;
}


inline bool Line3::is_degenerate() const
{
	return _d.is_zero();
}


inline Point3 Line3::point(int i) const
{
	return _p + (i * _d);
}


inline Point3 Line3::projection(const Point3 &p) const
{
	return _p + ((p - _p).dot(_d)) * _d;
}


END_GTBMOUSENS
