		
/// Rony! this is a part of the code of test_flattening.cpp
//  and the same in test_norm_partition.cpp.
//  I marked  ////! before the lines that you should insert
//  (or check that they are already there).

/*
 The log file must contain:

  1. name of the model
  2. running time
  3. relaxation or our
  4. if our alg, then vertex optimzed or not
  5. max_d value 
  6. mean_distortion value
  7. seam_length  (it is normalized. see in the code)

*/

		real sum_of_distortion = 0;
		////! max_d is the maximal distortion achieved
		real max_d = 0;
		for (int j = 0; j < mesh_vec.size(); ++j)
		{
			std::vector<real> tri_colors(0);
			mesh_vec[j].VisualizeDistortion(
				tm,
				maps2Dtriangle_to_3Dtriangle[j],
				tri_colors);

			sprintf(filename, "norm_patch_%d_d.simple", j);
			ofstream flat_mesh_d(filename);
			mesh_vec[j].WriteToSimpleFormat(flat_mesh_d, tri_colors);
			flat_mesh_d.close();

			for (int d = 0; d < tri_colors.size(); ++d)
			{
				sum_of_distortion += tri_colors[d] * 
					tm.GetTriangle(maps2Dtriangle_to_3Dtriangle[j][d]).GetArea();

				////! updating max_d
				if (tri_colors[d] > max_d)
					max_d = tri_colors[d];
			}
			tri_colors.clear();
		}
		// Rony! this is the value you wanted
		real mean_distortion = sum_of_distortion/tm.GetSurfaceArea();

		////! add mean distortion to log file
		cout << "Mean distortion = " << mean_distortion << endl;
		////! printing max_d --> add to log file!
		cout << "max distortion = " << max_d << endl;

		real seam_length = tm.CreatePatchBoundariesSet(mesh_vec, 
													   maps2Dtriangle_to_3Dtriangle);

		////! normalize seam length
		seam_length /= tm.GetTotalEdgeLength();
		////! add seam_length to log file
		cout << "The seam length is " << seam_length << endl;