#ifndef MYSTRING_H
#define MYSTRING_H

#include <stdio.h>
#include <string.h>

class myString {
public:
    myString(const char * str = "", bool literal = false) :
        m_block(0), m_str(0), m_size(0), m_capacity(0), m_hasSpace(false)
    { init(str, literal); }

    ~myString();
    
    void append(const char * str, bool literal = false);
    inline char * c_str() const { return m_str; }
    inline bool hasSpace() const { return m_hasSpace; }
    
private:
    void init(const char * str, bool literal);
    int length(const char * str, bool literal);
    void copy(const char * str, bool literal, int start);

    bool m_hasSpace;
    char * m_str;
    int m_size;
    int m_capacity;
    int m_block;
};

#endif
