void ITSView::select_face_under_cursor(int x, int y)
{
    static const int MAXSELECT=1000;
    GLuint selectBuf[MAXSELECT];
    GLint vp[4];

    glSelectBuffer(MAXSELECT, selectBuf);

    (void)glRenderMode(GL_SELECT);
    glInitNames();
    glPushName(12345678);

    _selected_face = -1;

    glGetIntegerv(GL_VIEWPORT, vp);

    {
        // open gl 0,0 is bottom left, while windows is top left?
        int window_height = glutGet(GLUT_WINDOW_HEIGHT);
        y = window_height - y;
        glMatrixMode(GL_PROJECTION);
        GLfloat m[16];
        glGetFloatv(GL_PROJECTION_MATRIX, m);
        glLoadIdentity();
        gluPickMatrix(x, y, 4, 4, vp);
        glMultMatrixf(m);
        glMatrixMode(GL_MODELVIEW );
    }
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    //
    // Render the triangles
    //
    unsigned N = _its->num_triangles();

	for (unsigned i = 0; i < N; i++) {
		const IndexedTriangle &ti = _its->indexed_triangle(i);

        glLoadName(i);
        glBegin(GL_TRIANGLES);
		_its->vertex_normal(ti[0]).load_as_normal();
		_its->vertex(ti[0]).load();

		_its->vertex_normal(ti[1]).load_as_normal();
		_its->vertex(ti[1]).load();

		_its->vertex_normal(ti[2]).load_as_normal();
		_its->vertex(ti[2]).load();
        glEnd();
	}


    //
    // End of rendering
    //

    int hits = glRenderMode(GL_RENDER); 

    if (hits < 0) 
    {
    	printf("Hit buffer is full\n");
    }
    else if (hits == 0) { _selected_face = -1; return; }
    else
    {
        GLuint names, *ptr;
        ptr = selectBuf;

        int selected_id;
        double closest=1e8;

        for (int i = 0; i < hits; i++) 
        {	/*  for each hit  */
            names = *ptr; ++ptr;
            double z1 = (double) *ptr/0x7fffffff; ++ptr;
            double z2 = (double) *ptr/0x7fffffff; ++ptr;
	    (void) z2;
            if (z1 < closest)
            {
              closest = z1;
              selected_id = *ptr;
            }
            ptr += names;
        }

        _selected_face = selected_id;
        printf("Selected face: %d\n", _selected_face);
    }

}
