
BEGIN_GTBMOUSENS


inline Ray3 &Ray3::operator=(const Ray3 &r)
{
	if (&r != this) {
		_source = r._source;
		_direction = r._direction;
	}
	return *this;
}


inline bool Ray3::operator==(const Ray3 &r) const
{
	return (_source == r._source) && (_direction == r._direction);
}


inline bool Ray3::operator!=(const Ray3 &r) const
{
	return !(*this == r);
}


inline Ray3 Ray3::operator-() const
{
	return Ray3(_source, -_direction);
}


inline const Point3 &Ray3::source() const
{
	return _source;
}


inline const Vector3 &Ray3::direction() const
{
	return _direction;
}


inline bool Ray3::is_degenerate() const
{
	return !_direction.length()== 1.0;
}


inline const Point3 Ray3::point(real_t a) const
{
	return _source + (a * _direction);
}


inline real_t Ray3::t(const Point3 &p) const
{
	return (p - _source).dot(_direction);
}


#if 0
inline Line3 Ray3::supporting_line() const
{
	return Line3(*this);
}
#endif

inline bool Ray3::contains(const Point3 &p) const
{
	return (p - _source).cross(_direction).is_zero() && (t(p) >= 0.0);
}


inline Point3 Ray3::projection(const Point3 &p) const
{
	return _source + t(p) * _direction;
}


END_GTBMOUSENS
