BEGIN_GTBMOUSENS


inline View &View::operator=(const View &view)
{
	if (&view != this) {
		_camera = view._camera;
		_viewport = view._viewport;
	}
	return *this;
}


inline const Camera &View::camera() const
{
	return _camera;
}


inline Camera &View::camera()
{
	return _camera;
}


inline Viewport &View::viewport()
{
	return _viewport;
}


inline const Viewport &View::viewport() const
{
	return _viewport;
}


inline void View::set_camera(const Camera &cam)
{
	_camera = cam;
}

inline void View::init_exterior_view(const Box3 &box)
{
	_camera.init_exterior_view(box);
}


inline void View::init_interior_view(const Box3 &box)
{
	_camera.init_interior_view(box);
}


inline void View::init_image_view(unsigned width, unsigned height)
{
	_viewport.resize(0, 0, width, height);
	_camera.init_image_view();
}


END_GTBMOUSENS
